﻿@model List<BackgroundTaskTimer>
@using SiteGuide.Service
@using SiteGuide.Web.Helpers
@using Humanizer
@{
    ViewData["Title"] = "Administration";
}

<h1>@ViewData["Title"]</h1>

<div class="row">
    @*    <div class="col-md-4">
    <form asp-action="Import" method="post">
    <h4>Clear all site data and import from xml.</h4>
    <button type="submit" class="btn btn-danger">Import</button>
    </form>
    </div>
    *@    <div class="col-md-4">
        <a class="btn btn-primary" href="/Versions">Versions</a>
        <a class="btn btn-primary" href="/Edit/All/Draft">Drafts</a>
        <a class="btn btn-primary" href="/Edit/All/Submitted">Submitted</a>
        <a class="btn btn-primary" href="/Edit/All/Rejected">Rejected</a>
    </div>
    <div class="col-md-4">
        <form asp-action="RefreshCacheUserClaimableEdits" method="post">
            <h4>Refresh UserClaimableEdits Cache</h4>
            <button type="submit" class="btn btn-warning">Refresh</button>
        </form>
    </div>
    @*<div class="col-md-4">
    <a class="btn btn-primary" href="/Admin/UpdateCtafData">Update CTAF data</a>
    </div>*@
    <div class="col-md-12">
        <h4>Background Tasks</h4>
        <table class="table table-hover">
            <thead>
                <tr>
                    <th>Task Id</th>
                    <th>Last run</th>
                    <th>Next run</th>
                    <th>Rerun Interval</th>
                    <th>Failure count</th>
                    <th>Initial Retry Interval</th>
                    <th>Subsequent Retry Multiplier</th>
                </tr>
            </thead>
            <tbody>
                @foreach (var task in Model)
                {
                    <tr @(task.CurrentFailuresCount > 0 ? "class=table-danger" : "")>
                        <td>@task.TaskId</td>
                        <td>
                            @if (task.LastUpdateUtc == null)
                            {
                                <text>Never</text>
                            }
                            else
                            {
                                @LocalTimeHelper.LocalTime((DateTime)task.LastUpdateUtc)
                                ;
                            }
                        </td>
                        <td>@LocalTimeHelper.LocalTime((DateTime)task.NextUpdateUtc)</td>
                        <td>@task.TaskRerunInterval.Humanize(9)</td>
                        <td>@task.CurrentFailuresCount</td>
                        <td>@task.InitialRetryInterval.Humanize(9)</td>
                        <td>@task.SubsequentRetryMultiplier</td>
                    </tr>
                }
            </tbody>
        </table>
    </div>
</div>
